UNIT mTKnopf;

interface

uses            dialogs,mSuM;
// Uses-Klausel ggf. anpassen

type
   TKnopf = CLASS

     // Attribute
     protected
         hatStift : BuntStift;
         kenntMaus : Maus;
         zGroesse : Zahl;
         zXPos : Zahl;
         zYPos : Zahl;
         zAufschrift : Zeichenkette;
     public
        meineClickAktion : procedure of Object;

     // Methoden
     protected
        procedure zeichne; virtual; abstract;
     public
        constructor init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus);
        procedure bearbeiteMeinenMausClick; virtual;
        procedure leereProzedur;
        function innerhalb : Wahrheitswert; virtual; abstract;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TKnopf.init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus);
begin
  zXpos := pX;
  zYPos := py;
  zGroesse := pGroesse;
  zAufschrift := pAufschrift;
  kenntMaus := pMaus;
  meineClickAktion := leereProzedur;
  hatStift := BuntStift.init;
  hatStift.wechsle;
  zeichne
end;

//-------- bearbeiteMeinenMausClick (public) ---------------------------
procedure TKnopf.bearbeiteMeinenMausClick;
begin
   if innerhalb
      then meineClickAktion
end;

//-------- leereProzedur (public) --------------------------------------
procedure TKnopf.leereProzedur;
begin
  //showmessage('leer Prozedur')
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKnopf.gibFrei;
begin
  zeichne
end;

end.
