UNIT mTEreignisbearbeiter;

interface

uses                    dialogs,mSuM;
// Uses-Klausel ggf. anpassen

type
   TEreignisbearbeiter = CLASS

     // Attribute
     protected
         kenntMaus : Maus;
         naechsterEreignisbearbeiter : TEreignisbearbeiter;
     public
        meineTastaturdruckAktion : procedure (sender : TObject ; pZeichen : Zeichen) of Object;
        meineLeerlaufAktion : procedure (sender : TObject) of Object;
        meineClickAktion : procedure(sender : TObject) of Object;
        meineDoppelklickAktion : procedure(sender : TObject) of Object;

     //Objektbeziehungen:
        // kenntTEreignisbearbeiter (0..1) of TEreignisbearbeiter;
        // kenntTEreignisbearbeiter () of TEreignisbearbeiter;

     // Methoden
     public
        constructor init(pMaus:Maus);
        procedure bearbeiteMeinenLeerlauf(sender : TObject); virtual;
        procedure bearbeiteMeinenMausClick(sender : TObject); virtual;
        procedure bearbeiteMeinenMausDoppelklick(sender : TObject); virtual;
        procedure bearbeiteMeinenTastaturDruck(Sender: TObject;  pZeichen:Zeichen); virtual;
        procedure haengeEreignisbearbeiterAn(pEreignisbearbeiter:TEreignisbearbeiter);
        procedure leereProzedur(sender : TObject);
        procedure leereTastaturProzedur(sender : TObject ; pZeichen:zeichen);
        destructor gibFrei; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TEreignisbearbeiter: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TEreignisbearbeiter.init(pMaus:Maus);
begin
  naechsterEreignisbearbeiter := nil;
  kenntMaus := pMaus;
  meineClickAktion := leereProzedur;
  meineDoppelklickaktion := leereProzedur;
  meineLeerlaufAktion := leereProzedur;
  meineTastaturDruckAktion := leereTastaturProzedur;
end;

//-------- bearbeiteMeinenLeerlauf (public) ----------------------------
procedure TEreignisbearbeiter.bearbeiteMeinenLeerlauf(sender : TObject);
begin
  meineLeerlaufAktion(self);
   if naechsterEreignisBearbeiter <> nil
      then naechsterEreignisBearbeiter.bearbeiteMeinenLeerlauf(sender)
end;

//-------- bearbeiteMeinenMausClick (public) ---------------------------
procedure TEreignisbearbeiter.bearbeiteMeinenMausClick(sender : TObject);
begin
   meineClickAktion(self) ;
   if naechsterEreignisBearbeiter <> nil
      then naechsterEreignisBearbeiter.bearbeiteMeinenMausClick(sender)
end;

//-------- bearbeiteMeinenMausDoppelklick (public) ---------------------
procedure TEreignisbearbeiter.bearbeiteMeinenMausDoppelklick(sender : TObject);
begin
   meineDoppelklickAktion(self) ;
   if naechsterEreignisBearbeiter <> nil
      then naechsterEreignisBearbeiter.bearbeiteMeinenMausDoppelklick(sender)
end;

//-------- bearbeiteMeinenTastaturDruck (public) -----------------------
procedure TEreignisbearbeiter.bearbeiteMeinenTastaturDruck(Sender: TObject;  pZeichen:Zeichen);
begin
   meineTastaturdruckAktion(self,pZeichen) ;
   if naechsterEreignisBearbeiter <> nil
      then naechsterEreignisBearbeiter.bearbeiteMeinenTastaturdruck(sender,pZeichen)
end;

//-------- haengeEreignisbearbeiterAn (public) -------------------------
procedure TEreignisbearbeiter.haengeEreignisbearbeiterAn(pEreignisbearbeiter:TEreignisbearbeiter);
begin
  if naechsterEreignisBearbeiter = nil
     then naechsterEreignisBearbeiter := pEreignisbearbeiter
     else naechsterEreignisBearbeiter.haengeEreignisbearbeiterAn(pEreignisbearbeiter);
end;

//-------- leereProzedur (public) --------------------------------------
procedure TEreignisbearbeiter.leereProzedur(sender : TObject);
begin
  //showmessage('dummy')
end;

//-------- leereTastaturProzedur (public) ------------------------------
procedure TEreignisbearbeiter.leereTastaturProzedur(sender : TObject ; pZeichen:zeichen);
begin
  //showmessage('TastaturDummy')
end;

//-------- gibFrei (public) --------------------------------------------
destructor TEreignisbearbeiter.gibFrei;
begin
   if naechsterEreignisBearbeiter <> nil
      then naechsterEreignisBearbeiter.gibFrei
end;

end.
