UNIT mTKnopf;

interface

uses                   dialogs,mSuM,mTEreignisbearbeiter;
// Uses-Klausel ggf. anpassen

type
   TKnopf = CLASS(TEreignisbearbeiter)

     // Attribute
     protected
         hatStift : BuntStift;
         zGroesse : Zahl;
         zXPos : Zahl;
         zYPos : Zahl;
         zAufschrift : Zeichenkette;

     // Methoden
     protected
        procedure zeichne; virtual;
     public
        constructor init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus);
        procedure bearbeiteMeinenMausClick(sender : TObject); override;
        procedure bearbeiteMeinenMausDoppelklick(sender : TObject); override;
        function innerhalb : Wahrheitswert; virtual;
        destructor gibFrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (protected) -----------------------------------------
procedure TKnopf.zeichne;
begin
  //Hier Code einfgen.
end;

//-------- init (public) -----------------------------------------------
constructor TKnopf.init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus);
begin
  zXpos := pX;
  zYPos := py;
  zGroesse := pGroesse;
  zAufschrift := pAufschrift;
  hatStift := BuntStift.init;
  hatStift.wechsle;
  inherited init(pMaus);
  zeichne
end;

//-------- bearbeiteMeinenMausClick (public) ---------------------------
procedure TKnopf.bearbeiteMeinenMausClick(sender : TObject);
begin
   if self.innerhalb
      then meineClickAktion(sender) ;
   if naechsterEreignisBearbeiter <> nil
      then naechsterEreignisbearbeiter.bearbeiteMeinenMausClick(sender)
end;

//-------- bearbeiteMeinenMausDoppelklick (public) ---------------------
procedure TKnopf.bearbeiteMeinenMausDoppelklick(sender : TObject);
begin
   if self.innerhalb
      then meineDoppelklickAktion(sender) ;
   if naechsterEreignisBearbeiter <> nil
      then naechsterEreignisBearbeiter.bearbeiteMeinenMausDoppelklick(sender)
end;

//-------- innerhalb (public) ------------------------------------------
function TKnopf.innerhalb : Wahrheitswert;
begin
  result := false
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKnopf.gibFrei;
begin
  zeichne;
  inherited gibFrei
end;

end.
