UNIT mTKnopf;

interface

uses              dialogs,mSuM;
// Uses-Klausel ggf. anpassen

type
   TKnopf = CLASS

     // Attribute
     private
        naechsterKnopf : TKnopf;
     protected
         hatStift : BuntStift;
         kenntMaus : Maus;
         zGroesse : Zahl;
         zXPos : Zahl;
         zYPos : Zahl;
         zAufschrift : Zeichenkette;
     public
        meineClickAktion : procedure of Object;

     //Objektbeziehungen:
        // kenntTKnopf (0..1) of TKnopf;
        // kenntTKnopf () of TKnopf;

     // Methoden
     protected
        procedure zeichne; virtual;
     public
        constructor init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus);
        procedure bearbeiteMeinenMausClick; virtual;
        procedure haengeKnopfAn(pKnopf:TKnopf);
        procedure leereProzedur;
        function innerhalb : Wahrheitswert; virtual;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (protected) -----------------------------------------
procedure TKnopf.zeichne;
begin
  //Hier Code einfgen.
end;

//-------- init (public) -----------------------------------------------
constructor TKnopf.init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus);
begin
  naechsterKnopf := nil; 
  zXpos := pX;
  zYPos := py;
  zGroesse := pGroesse;
  zAufschrift := pAufschrift;
  kenntMaus := pMaus;
  meineClickAktion := leereProzedur;
  hatStift := BuntStift.init;
  hatStift.wechsle;
  zeichne
end;

//-------- bearbeiteMeinenMausClick (public) ---------------------------
procedure TKnopf.bearbeiteMeinenMausClick;
begin
   if self.innerhalb
      then meineClickAktion ;
   if naechsterKnopf <> nil
      then naechsterKnopf.bearbeiteMeinenMausClick
end;

//-------- haengeKnopfAn (public) --------------------------------------
procedure TKnopf.haengeKnopfAn(pKnopf:TKnopf);
begin
  if naechsterKnopf = nil
     then naechsterKnopf := pKnopf
     else naechsterKnopf.haengeKnopfAn(pKnopf);
end;

//-------- leereProzedur (public) --------------------------------------
procedure TKnopf.leereProzedur;
begin
  //showmessage('dummy')
end;

//-------- innerhalb (public) ------------------------------------------
function TKnopf.innerhalb : Wahrheitswert;
begin
  result := false
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKnopf.gibFrei;
begin
  zeichne
end;

end.
