UNIT mTEreignisbearbeiter;

interface

uses                  dialogs,mSuM;
// Uses-Klausel ggf. anpassen

type
   TEreignisbearbeiter = CLASS

     // Attribute
     protected
         kenntMaus : Maus;
         naechsterEreignisbearbeiter : TEreignisbearbeiter;
     public
        meineTastaturdruckAktion : procedure ( pZeichen : Zeichen) of Object;
        meineClickAktion : procedure of Object;
        meineDoppelklickAktion : procedure of Object;
        meineLeerlaufAktion : procedure of Object;

     //Objektbeziehungen:
        // kenntTEreignisbearbeiter (0..1) of TEreignisbearbeiter;
        // kenntTEreignisbearbeiter () of TEreignisbearbeiter;

     // Methoden
     public
        constructor init(pMaus:Maus);
        procedure bearbeiteMeinenLeerlauf; virtual;
        procedure bearbeiteMeinenMausClick; virtual;
        procedure bearbeiteMeinenMausDoppelklick; virtual;
        procedure bearbeiteMeinenTastaturDruck(pZeichen:Zeichen); virtual;
        procedure haengeEreignisbearbeiterAn(pEreignisbearbeiter:TEreignisbearbeiter);
        procedure leereProzedur;
        procedure leereTastaturProzedur(pZeichen:zeichen);
        destructor gibFrei; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TEreignisbearbeiter: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TEreignisbearbeiter.init(pMaus:Maus);
begin
  naechsterEreignisbearbeiter := nil;
  kenntMaus := pMaus;
  meineClickAktion := leereProzedur;
  meineDoppelklickaktion := leereProzedur;
  meineLeerlaufAktion := leereProzedur;
  meineTastaturDruckAktion := leereTastaturProzedur;
end;

//-------- bearbeiteMeinenLeerlauf (public) ----------------------------
procedure TEreignisbearbeiter.bearbeiteMeinenLeerlauf;
begin
  meineLeerlaufAktion;
   if naechsterEreignisBearbeiter <> nil
      then naechsterEreignisBearbeiter.bearbeiteMeinenLeerlauf
end;

//-------- bearbeiteMeinenMausClick (public) ---------------------------
procedure TEreignisbearbeiter.bearbeiteMeinenMausClick;
begin
   meineClickAktion ;
   if naechsterEreignisBearbeiter <> nil
      then naechsterEreignisBearbeiter.bearbeiteMeinenMausClick
end;

//-------- bearbeiteMeinenMausDoppelklick (public) ---------------------
procedure TEreignisbearbeiter.bearbeiteMeinenMausDoppelklick;
begin
   meineDoppelklickAktion ;
   if naechsterEreignisBearbeiter <> nil
      then naechsterEreignisBearbeiter.bearbeiteMeinenMausDoppelklick
end;

//-------- bearbeiteMeinenTastaturDruck (public) -----------------------
procedure TEreignisbearbeiter.bearbeiteMeinenTastaturDruck(pZeichen:Zeichen);
begin
   meineTastaturdruckAktion(pZeichen) ;
   if naechsterEreignisBearbeiter <> nil
      then naechsterEreignisBearbeiter.bearbeiteMeinenTastaturdruck(pZeichen)
end;

//-------- haengeEreignisbearbeiterAn (public) -------------------------
procedure TEreignisbearbeiter.haengeEreignisbearbeiterAn(pEreignisbearbeiter:TEreignisbearbeiter);
begin
  if naechsterEreignisBearbeiter = nil
     then naechsterEreignisBearbeiter := pEreignisbearbeiter
     else naechsterEreignisBearbeiter.haengeEreignisbearbeiterAn(pEreignisbearbeiter);
end;

//-------- leereProzedur (public) --------------------------------------
procedure TEreignisbearbeiter.leereProzedur;
begin
  //showmessage('dummy')
end;

//-------- leereTastaturProzedur (public) ------------------------------
procedure TEreignisbearbeiter.leereTastaturProzedur(pZeichen:zeichen);
begin
  //showmessage('TastaturDummy')
end;

//-------- gibFrei (public) --------------------------------------------
destructor TEreignisbearbeiter.gibFrei;
begin
   if naechsterEreignisBearbeiter <> nil
      then naechsterEreignisBearbeiter.gibFrei
end;

end.
