UNIT mTEreignisbearbeiter;

interface

uses  mSuM, mTAnwendung;
// Uses-Klausel ggf. anpassen

type
   TEreignisbearbeiter = CLASS

     // Attribute
     protected
         kenntMaus : Maus;
         kenntAnwendung : TAnwendung;
         naechsterBearbeiter : TEreignisbearbeiter;

     //Objektbeziehungen:
        // kenntTEreignisbearbeiter () of TEreignisbearbeiter;
        // kenntTEreignisbearbeiter (0..1) of TEreignisbearbeiter;

     // Methoden
     public
        constructor init(pAnwendung:TAnwendung);
        procedure bearbeiteLeerlauf; virtual;
        procedure bearbeiteMausClick; virtual;
        procedure bearbeiteMausDoppelklick; virtual;
        procedure bearbeiteTastaturdruck; virtual;
        procedure haengeEreignisbearbeiterAn(pBearbeiter:TEreignisBearbeiter);
        destructor gibFrei; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TEreignisbearbeiter: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TEreignisbearbeiter.init(pAnwendung:TAnwendung);
begin
  //showmessage('init');
  kenntMaus := pAnwendung.dieMaus;
  kenntAnwendung := pAnwendung;
  naechsterBearbeiter := nil;
end;

//-------- bearbeiteLeerlauf (public) ----------------------------------
procedure TEreignisbearbeiter.bearbeiteLeerlauf;
begin
  //showmessage(' bearbeite keinEreignis.');
  if naechsterBearbeiter = nil then
     //showmessage('letzter Bearbeiter')
  else
  begin
     naechsterBearbeiter.bearbeiteLeerlauf;
  end
end;

//-------- bearbeiteMausClick (public) ---------------------------------
procedure TEreignisbearbeiter.bearbeiteMausClick;
begin
  //showmessage(' bearbeitet Mausclick.');
  if naechsterBearbeiter = nil then
     //showmessage('Knopf '+zAufschrift+ ' ist letzter Knopf.')
  else
  begin
     //showmessage ('Knopf '+zAufschrift+ ' gibt Klick weiter.');
     naechsterBearbeiter.bearbeiteMausClick;
     //showmessage('Folgeknpfe von ' + zAufschrift +' sind fertig');
  end
end;

//-------- bearbeiteMausDoppelklick (public) ---------------------------
procedure TEreignisbearbeiter.bearbeiteMausDoppelklick;
begin
  if naechsterBearbeiter <> nil then
     naechsterBearbeiter.bearbeiteMausDoppelklick
end;

//-------- bearbeiteTastaturdruck (public) -----------------------------
procedure TEreignisbearbeiter.bearbeiteTastaturdruck;
begin
end;

//-------- haengeEreignisbearbeiterAn (public) -------------------------
procedure TEreignisbearbeiter.haengeEreignisbearbeiterAn(pBearbeiter:TEreignisBearbeiter);
begin
  if naechsterBearbeiter = nil
     then naechsterBearbeiter := pBearbeiter
     else naechsterBearbeiter.haengeEreignisbearbeiterAn(pBearbeiter);
end;

//-------- gibFrei (public) --------------------------------------------
destructor TEreignisbearbeiter.gibFrei;
begin
 //showmessage('gib frei');
 if naechsterBearbeiter <> nil then
     naechsterBearbeiter.gibFrei;
end;

end.
