UNIT mTGueterwagen;

interface

uses  mSum, mTEreignisWaggon;
// Uses-Klausel ggf. anpassen

type
   TGueterwagen = CLASS(TEreignisWaggon)

     // Attribute

     // Methoden
     public
        procedure zeichne; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TGueterwagen: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (public) --------------------------------------------
procedure TGueterwagen.zeichne;
begin
  hatStift.hoch;
  hatStift.bewegeBis(self.hPosition, self.vPosition);
  hatStift.runter;

  //Puffer links
  hatStift.dreheBis(90); //oben
  hatStift.bewegeUm(3);
  hatStift.dreheUm(180); //unten
  hatStift.hoch;
  hatStift.bewegeUm(6);
  hatStift.runter;
  hatStift.dreheUm(180); //oben
  hatStift.bewegeUm(3);
  hatStift.dreheUm(270); //rechts
  hatStift.bewegeUm(5);

  //Boden
  hatStift.hoch;
  hatStift.dreheUm(90); //oben
  hatStift.bewegeUm(10);
  hatStift.zeichneRechteck(100,15);

  //Wand links
  hatStift.bewegeUm(30);
  hatStift.dreheUm(-90); //rechts
  hatStift.bewegeUm(1);
  hatStift.zeichneRechteck(5,30);

  //Wand rechts
  hatStift.bewegeUm(93);
  hatStift.zeichneRechteck(5,30);

  //Rder
  hatStift.bewegeUm(-4);
  hatStift.dreheUm(270); //unten
  hatStift.bewegeUm(50);
  hatStift.zeichneKreis(5);
  hatStift.dreheUm(90);  //rechts
  hatStift.bewegeUm(-80);
  hatStift.zeichneKreis(5);
  hatStift.bewegeUm(90);
  hatStift.dreheUm(90); //oben
  hatStift.bewegeUm(10);

  //Puffer rechts
  hatStift.runter;
  hatStift.dreheUm(270); //rechts
  hatStift.bewegeUm(5);
  hatStift.dreheUm(90);  //oben
  hatStift.bewegeUm(3);
  hatStift.dreheUm(180); //unten
  hatStift.hoch;
  hatStift.bewegeUm(6);
  hatStift.runter;
  hatStift.dreheUm(180); //oben
  hatStift.bewegeUm(3);
end;

end.
