UNIT mEreignisBearbeiterAnwendung;

interface

uses  mSuM, mEreignisbearbeiter,mEreignisverteiler,mEreignisanwendung;
// Uses-Klausel ggf. anpassen

type
   EreignisBearbeiterAnwendung = CLASS(Ereignisanwendung)

     // Attribute
     public
        hatEreignisverteiler : Ereignisverteiler;

     //Objektbeziehungen:
        // hatEreignisverteiler : Ereignisverteiler;
        // hatEreignisBearbeiter (0..n) of EreignisBearbeiter;

     // Methoden
     public
        constructor init; override;
        procedure bearbeiteDoppelKlick(pHPosition,pVPosition:Zahl); override;
        procedure bearbeiteLeerlauf; override;
        procedure bearbeiteMausBewegt(pHPositioninH,pHPositioninV:Zahl); override;
        procedure bearbeiteMausDruck(pHPosition,pVPosition:Zahl); override;
        procedure bearbeiteMausLos(pHPosition,pVPosition:Zahl); override;
        procedure bearbeiteTaste(pZeichen:Zeichen); override;
        procedure neuerEreignisbearbeiter(pNeu:ereignisBearbeiter); virtual;
        destructor gibFrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         EreignisBearbeiterAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor EreignisBearbeiterAnwendung.init;
  begin
    inherited init;
    hatEreignisverteiler:=Ereignisverteiler.init;
  end;

//-------- bearbeiteDoppelKlick (public) -------------------------------
procedure EreignisBearbeiterAnwendung.bearbeiteDoppelKlick(pHPosition,pVPosition:Zahl);
  begin
    hatEreignisverteiler.bearbeiteDoppelKlick(pHPosition,pVPosition);
  end;

//-------- bearbeiteLeerlauf (public) ----------------------------------
procedure EreignisBearbeiterAnwendung.bearbeiteLeerlauf;
  begin
    hatEreignisverteiler.bearbeiteLeerlauf;
  end;

//-------- bearbeiteMausBewegt (public) --------------------------------
procedure EreignisBearbeiterAnwendung.bearbeiteMausBewegt(pHPositioninH,pHPositioninV:Zahl);
  begin
    hatEreignisverteiler.bearbeiteMausBewegt(pHPositioninH,pHPositioninV);
  end;

//-------- bearbeiteMausDruck (public) ---------------------------------
procedure EreignisBearbeiterAnwendung.bearbeiteMausDruck(pHPosition,pVPosition:Zahl);
  begin
    hatEreignisverteiler.bearbeiteMausDruck(pHPosition,pVPosition);
  end;

//-------- bearbeiteMausLos (public) -----------------------------------
procedure EreignisBearbeiterAnwendung.bearbeiteMausLos(pHPosition,pVPosition:Zahl);
  begin
    hatEreignisverteiler.bearbeiteMausLos(pHPosition,pVPosition);
  end;

//-------- bearbeiteTaste (public) -------------------------------------
procedure EreignisBearbeiterAnwendung.bearbeiteTaste(pZeichen:Zeichen);
  begin
    hatEreignisverteiler.bearbeiteTaste(pZeichen);
  end;

//-------- neuerEreignisbearbeiter (public) ----------------------------
procedure EreignisBearbeiterAnwendung.neuerEreignisbearbeiter(pNeu:ereignisBearbeiter);
  begin
    hatEreignisverteiler.einfuegen(pNeu);
  end;

//-------- gibFrei (public) --------------------------------------------
destructor EreignisBearbeiterAnwendung.gibFrei;
  begin
    hatEreignisverteiler.gibFrei;
    inherited gibFrei;
  end;





{ Tastaturpuffer (Hilfsklasse) ************************************************}

{#k Die Klasse Tastaturpuffer wurde so umgeschrieben, das sie auf Ereignisse der
                                               TForm Komponente reagieren kann }

end.
