UNIT mTEreignisAnwendung;

interface

uses       mSum,mTAnwendung, mTEndeKnopf;
// Uses-Klausel ggf. anpassen

type
   TEreignisAnwendung = CLASS(TAnwendung)

     // Attribute
     protected
         KnopfEnde : TEndeKnopf;
         zBeenden : Wahrheitswert;
         zMausUnten : Wahrheitswert;

     //Objektbeziehungen:
        // hatTEndeKnopf : TEndeKnopf;

     // Methoden
     public
        constructor init; override;
        procedure bearbeiteLeerlauf;
        procedure bearbeiteMausClick;
        procedure bearbeiteMausDoppelklick;
        procedure bearbeiteTastaturDruck; 
        procedure beenden;
        procedure run; override;
        destructor gibfrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TEreignisAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TEreignisAnwendung.init;
begin
  inherited init;
  KnopfEnde          := TEndeKnopf.init(derBildschirm.breite-101,1,100,'Ende',dieMaus,self);
  zBeenden           := falsch;
  zMausunten         := falsch;
end;

//-------- bearbeiteLeerlauf (public) ----------------------------------
procedure TEreignisAnwendung.bearbeiteLeerlauf;
begin
  KnopfEnde.bearbeiteLeerlauf
end;

//-------- bearbeiteMausClick (public) ---------------------------------
procedure TEreignisAnwendung.bearbeiteMausClick;
begin
  KnopfEnde.bearbeiteMausClick
end;

//-------- bearbeiteMausDoppelklick (public) ---------------------------
procedure TEreignisAnwendung.bearbeiteMausDoppelklick;
begin
  KnopfEnde.bearbeiteMausDoppelklick
end;

//-------- bearbeiteTastaturDruck (public) -----------------------------
procedure TEreignisAnwendung.bearbeiteTastaturDruck;
begin
 // KnopfEnde.bearbeiteTastaturDruck
end;

//-------- beenden (public) --------------------------------------------
procedure TEreignisAnwendung.beenden;
begin
   zBeenden := True
end;

//-------- run (public) ------------------------------------------------
procedure TEreignisAnwendung.run;
begin
  repeat
     if dieMaus.istGedrueckt
       then begin
              if not zMausUnten
                then begin
                       zMausUnten := True;
                       bearbeiteMausClick
                     end
                else begin
                       bearbeiteLeerlauf
                       //bearbeiteMausUnten
                     end
            end
       else begin //Maus ist nicht gedrckt
              zMausUnten := False;
              if dieMaus.doppelklick
                then begin
                       bearbeiteMausDoppelklick
                     end
                else begin
                       if dieTastatur.wurdeGedrueckt
                         then begin
                                bearbeiteTastaturDruck
                              end
                         else begin
                                bearbeiteLeerlauf
                              end
                     end
            end
  until zBeenden
end;

  // Aufrumen

//-------- gibfrei (public) --------------------------------------------
destructor TEreignisAnwendung.gibfrei;
begin
end;  

end.
